// Automatic Xylophone
// Build instruction & details on:
// https://homofaciens.de/technics-physical-computing-examples-Xylophone_en.htm
//
// License: GPL V3 (see https://www.gnu.org/licenses/gpl-3.0.html)


#define TONE_G_1    22
#define TONE_GIS_1  23
#define TONE_A_1    24
#define TONE_AIS_1  25
#define TONE_H_1    26
#define TONE_C_2    27
#define TONE_CIS_2  28
#define TONE_D_2    29
#define TONE_DIS_2  30
#define TONE_E_2    31
#define TONE_F_2    32
#define TONE_FIS_2  33
#define TONE_G_2    34
#define TONE_GIS_2  35
#define TONE_A_2    36
#define TONE_AIS_2  37
#define TONE_H_2    38
#define TONE_C_3    39
#define TONE_CIS_3  40
#define TONE_D_3    41
#define TONE_DIS_3  42
#define TONE_E_3    43
#define TONE_F_3    44
#define TONE_FIS_3  45
#define TONE_G_3    46

#define LED_G_1     47
#define LED_GIS_1   48
#define LED_A_1     49
#define LED_AIS_1   50
#define LED_H_1     51
#define LED_C_2     53
#define LED_CIS_2   52
#define LED_D_2     21
#define LED_DIS_2   20
#define LED_E_2     19
#define LED_F_2     18
#define LED_FIS_2   17
#define LED_G_2     16
#define LED_GIS_2   15
#define LED_A_2     14
#define LED_AIS_2   2
#define LED_H_2     3
#define LED_C_3     4
#define LED_CIS_3   5
#define LED_D_3     6
#define LED_DIS_3   7
#define LED_E_3     8
#define LED_F_3     9
#define LED_FIS_3   10
#define LED_G_3     11



//#define TONE_ON_TIME   15
int TONE_ON_TIME = 15;
#define TONE_LENGTH   200
#define MAX_TONES      25
#define MELODY_MAX     61

int mode = 0;
int tone_plus = 1;

byte readChar;

byte play_tones[MAX_TONES];

int tones_2_GPIO[MAX_TONES] = {
        TONE_G_1,
        TONE_GIS_1,
        TONE_A_1,
        TONE_AIS_1,
        TONE_H_1,
        TONE_C_2,
        TONE_CIS_2,
        TONE_D_2,
        TONE_DIS_2,
        TONE_E_2,
        TONE_F_2,
        TONE_FIS_2,
        TONE_G_2,
        TONE_GIS_2,
        TONE_A_2,
        TONE_AIS_2,
        TONE_H_2,
        TONE_C_3,
        TONE_CIS_3,
        TONE_D_3,
        TONE_DIS_3,
        TONE_E_3,
        TONE_F_3,
        TONE_FIS_3,
        TONE_G_3
      };

int LEDs_2_GPIO[MAX_TONES] = {
        LED_G_1,
        LED_GIS_1,
        LED_A_1,
        LED_AIS_1,
        LED_H_1,
        LED_C_2,
        LED_CIS_2,
        LED_D_2,
        LED_DIS_2,
        LED_E_2,
        LED_F_2,
        LED_FIS_2,
        LED_G_2,
        LED_GIS_2,
        LED_A_2,
        LED_AIS_2,
        LED_H_2,
        LED_C_3,
        LED_CIS_3,
        LED_D_3,
        LED_DIS_3,
        LED_E_3,
        LED_F_3,
        LED_FIS_3,
        LED_G_3
      };

int melody_t1[] = {9,9,10,12,12,10,9,7,5,5,7,9,9,7,7,9,9,10,12,12,10,9,7,5,5,7,9,7,5,5,7,9,5,7,9,10,9,5,7,9,10,9,7,5,7,0,9,9,10,12,12,10,9,7,5,5,7,9,7,5,5};
int melody_l1[] = {2,2, 2, 2, 2, 2,2,2,2,2,2,2,3,1,4,2,2, 2, 2, 2, 2,2,2,2,2,2,2,3,1,4,4,2,2,2,1, 1,2,2,2,1, 1,2,2,2,2,4,2,2, 2, 2, 2, 2,2,2,2,2,2,2,3,1,40};


void beat_tones(){
  for(int i = 0; i < MAX_TONES; i++){
    if(play_tones[i]){
      digitalWrite(tones_2_GPIO[i], 1);
      digitalWrite(LEDs_2_GPIO[i], 1);
    }
  }
  delay(TONE_ON_TIME);
  for(int i = 0; i < MAX_TONES; i++){
    if(play_tones[i]){
      digitalWrite(tones_2_GPIO[i], 0);
      play_tones[i] = 0;
    }
  }
  delay(TONE_LENGTH - TONE_ON_TIME);
}

void setup() {
  
  for(int i = 0; i < MAX_TONES; i++){
    pinMode(tones_2_GPIO[i], OUTPUT);
    pinMode(LEDs_2_GPIO[i], OUTPUT);
    digitalWrite(LEDs_2_GPIO[i], 0);
    play_tones[i] = 0;
  }

  readChar = 0;
  mode = 4; // 0 - 4
  
  // start serial port at 115200 bps:
  Serial.begin(115200);

  //delay(5000);

}


void loop(void) {

  if (Serial.available() > 0){ //if we get a valid byte, read from serial:
    readChar = Serial.read();     //get incoming byte:
    Serial.write('r');            // send a 'r' to initiate next data from computer
  }


  if(mode == 0){
    // Play all tones ++++++++++++++++++++++++++
    delay(1000);
    // UP
    for(int i = 0; i < MAX_TONES; i++){
      play_tones[i] = 1;
      beat_tones();
      digitalWrite(LEDs_2_GPIO[i], 1);
      delay(250);
      digitalWrite(LEDs_2_GPIO[i], 0);
    }
    // DOWN
    for(int i = MAX_TONES-1; i > -1; i--){
      play_tones[i] = 1;
      beat_tones();
      digitalWrite(LEDs_2_GPIO[i], 1);
      delay(250);
      digitalWrite(LEDs_2_GPIO[i], 0);
    }
    delay(10000);
  }// -------------------------------------------

  
  if(mode == 1){
    // Melody shift for +1 and +7 ++++++++++++++
    tone_plus = 1;
    for(int j = 0; j < 2; j++){
      if(j==1)tone_plus = 7;
      for(int i = 0; i < 15; i++){
        play_tones[melody_t1[i]] = 1;
        beat_tones();
        delay(TONE_LENGTH * (melody_l1[i]-1));
        for(int j = 0; j < MAX_TONES; j++){
          digitalWrite(LEDs_2_GPIO[j], 0);
        }
      }
      delay(2000);
      for(int i = 0; i < 15; i++){
        play_tones[melody_t1[i] + tone_plus] = 1;
        beat_tones();
        delay(TONE_LENGTH * (melody_l1[i]-1));
        for(int j = 0; j < MAX_TONES; j++){
          digitalWrite(LEDs_2_GPIO[j], 0);
        }
      }
      delay(10000);
    }
  }// -----------------------------------------

  if(mode == 2){
    // Melody +1, +3, +7 and +12 simultaneous ++
    tone_plus = 1;
    for(int j = 0; j < 4; j++){
      if(j==1)tone_plus = 7;
      if(j==2)tone_plus = 12;
      if(j==3)tone_plus = 3;
      for(int i = 0; i < 15; i++){
        play_tones[melody_t1[i]] = 1;
        if(melody_t1[i] + tone_plus < MAX_TONES){
          play_tones[melody_t1[i] + tone_plus] = 1;
        }
        beat_tones();
        delay(TONE_LENGTH * (melody_l1[i]-1));
        for(int j = 0; j < MAX_TONES; j++){
          digitalWrite(LEDs_2_GPIO[j], 0);
        }
      }
      delay(10000);
    }
  }// -----------------------------------------



  if(mode == 3){
    // Learn melody ++++++++++++++++++++++++++++
    for(int j = 3; j < MELODY_MAX; j+=3){
      for(int i = 0; i < j; i++){
        play_tones[melody_t1[i]] = 1;
        beat_tones();
        delay(TONE_LENGTH * (melody_l1[i]-1));
        for(int j = 0; j < MAX_TONES; j++){
          digitalWrite(LEDs_2_GPIO[j], 0);
        }
      }
      delay(j*TONE_LENGTH * 3 + 1500);
    }
  }// -----------------------------------------



  if(mode == 4){
    // Full melody +++++++++++++++++++++++++++++
    for(int i = 0; i < MELODY_MAX; i++){
      play_tones[melody_t1[i]] = 1;
      if(i > 14 && melody_t1[i] + 12 < MAX_TONES){
        play_tones[melody_t1[i]+12] = 1;
      }
      if(i > 29 && melody_t1[i] + 7 < MAX_TONES){
        play_tones[melody_t1[i]+7] = 1;
        TONE_ON_TIME = 15;
      }
      if(i > 45 && melody_t1[i] + 4 < MAX_TONES){
        play_tones[melody_t1[i]+4] = 1;
      }
  
      beat_tones();
      delay(TONE_LENGTH * (melody_l1[i]-1));
      for(int j = 0; j < MAX_TONES; j++){
        digitalWrite(LEDs_2_GPIO[j], 0);
      }
    }
  }// -------------------------------------------
  
} 
